/* "Magisches Quadrat"
*/
public class MagischesQuadrat {
	
	// Print Matrix a
	public static void printMatrix(int[][] a) {
		int i = 0; 
		while(i < a.length) {
			int j = 0;
			while(j < a[0].length) {
				System.out.print(a[i][j] + " ");
				j++;
			}
			System.out.println();
			i++;
		}
		System.out.println();
	}
	
	// Check if a is a magic square
	public static boolean isMagicSquare(int[][] a) {
		int i = 0; 
		int j = 0;
		int sum;
		int n = a.length;
		int magicSum = 0;
		
		//--- check diagonals
		while(i < n) {
			magicSum = magicSum + a[i][i];
			i++;
		}
		sum = 0;
		i = 0;
		while( i < n ) {
			sum = sum + a[i][n-i-1];
			i++;
		}
		if (sum != magicSum) {
			return false;
		}
		
		//--- check rows
		i = 0;
		while(i < n) {
			sum = 0;
			j = 0;
			while(j < n) {
				sum = sum + a[i][j];
				j++;
			}
			if (sum != magicSum) {
				return false;
			}
			i++;
		}
		
		//--- check columns
		j = 0;
		while(j < n) {
			sum = 0;
			i = 0;
			while(i < n){
				sum = sum + a[i][j];
				i++;
			}
			j++;
			if (sum != magicSum) {
				return false;
			}
		}
		return true;
	}
	
	public static void main(String[] arg) {
		
		int[][] a = {{12,6,15,1},{13,3,10,8},{2,16,5,11},{7,9,4,14}};
		System.out.println("Eingabe: ");
		printMatrix(a);
		if (isMagicSquare(a))
			System.out.println("Die Matrix ist ein magisches Quadrat");
		else
			System.out.println("Die Matrix ist kein magisches Quadrat");
	}
}